Subject: Re: [PATCH net-next v2 5/7] usbnet: smsc95xx: Forward PHY interrupts to PHY driver to avoid polling

From: Marc Zyngier <[email-masked]>
Date: Mon, 09 May 2022 09:47:19 +0100

On Fri, 06 May 2022 21:16:47 +0100,
Lukas Wunner <[email-masked]> wrote:
> 
> On Fri, May 06, 2022 at 11:58:43AM +0100, Marc Zyngier wrote:
> > On Thu, 05 May 2022 19:53:28 +0100, Lukas Wunner <[email-masked]> wrote:
> > > On Thu, May 05, 2022 at 11:32:07AM -0700, Jakub Kicinski wrote:
> > > > On Tue, 3 May 2022 15:15:05 +0200 Lukas Wunner wrote:
> > > > > @@ -608,11 +618,20 @@ static void smsc95xx_status(struct usbnet *dev, struct urb *urb)
> > > > >  	intdata = get_unaligned_le32(urb->transfer_buffer);
> > > > >  	netif_dbg(dev, link, dev->net, "intdata: 0x%08X\n", intdata);
> > > > >  
> > > > > +	/* USB interrupts are received in softirq (tasklet) context.
> > > > > +	 * Switch to hardirq context to make genirq code happy.
> > > > > +	 */
> > > > > +	local_irq_save(flags);
> > > > > +	__irq_enter_raw();
> > > > > +
> > > > >  	if (intdata & INT_ENP_PHY_INT_)
> > > > > -		;
> > > > > +		generic_handle_domain_irq(pdata->irqdomain, PHY_HWIRQ);
> > > > >  	else
> > > > >  		netdev_warn(dev->net, "unexpected interrupt, intdata=0x%08X\n",
> > > > >  			    intdata);
> > > > > +
> > > > > +	__irq_exit_raw();
> > > > > +	local_irq_restore(flags);
> > > > 
> > > > Full patch:
> > > > 
> > > > https://lore.kernel.org/all/[email-masked]/
> > > 
> > > This is basically identical to what drivers/net/usb/lan78xx.c does
> > > in lan78xx_status(), except I'm passing the hw irq instead of the
> > > linux irq to genirq code, thereby avoiding the overhead of a
> > > radix_tree_lookup().
> > > 
> > > generic_handle_domain_irq() warns unconditionally on !in_irq(),
> > > unlike handle_irq_desc(), which constrains the warning to
> > > handle_enforce_irqctx() (i.e. x86 APIC, arm GIC/GICv3).
> > > Perhaps that's an oversight in generic_handle_domain_irq(),
> > > unless __irq_resolve_mapping() becomes unsafe outside in_irq()
> > > for some reason...
> > > 
> > > In any case the unconditional in_irq() necessitates __irq_enter_raw()
> > > here.
> > > 
> > > And there's no _safe variant() of generic_handle_domain_irq()
> > > (unlike generic_handle_irq_safe() which was recently added by
> > > 509853f9e1e7), hence the necessity of an explicit local_irq_save().
> > 
> > Please don't directly use __irq_enter_raw() and similar things
> > directly in driver code (it doesn't do anything related to RCU, for
> > example, which could be problematic if used in arbitrary contexts).
> > Given how infrequent this interrupt is, I'd rather you use something
> > similar to what lan78xx is doing, and be done with it.
> > 
> > And since this is a construct that seems to be often repeated, why
> > don't you simply make the phy interrupt handling available over a
> > smp_call_function() interface, which would always put you in the
> > correct context and avoid faking things up?
> 
> As I've explained in the commit message (linked above), LAN95xx chips
> have 11 GPIOs which can be an interrupt source.  This patch adds
> PHY interrupt support in such a way that GPIO interrupts can easily
> be supported by a subsequent commit.  To this end, LAN95xx needs
> to be represented as a proper irqchip.
>
> The crucial thing to understand is that a USB interrupt is not received
> as a hardirq.  USB gadgets are incapable of directly signaling an
> interrupt because they cannot initiate a bus transaction by themselves.
> All communication on the bus is initiated by the host controller,
> which polls a gadget's Interrupt Endpoint in regular intervals.
> If an interrupt is pending, that information is passed up the stack
> in softirq context.  Hence there's no other way than "faking things up",
> to borrow your language.
>
> Another USB driver in the tree, drivers/gpio/gpio-dln2.c, likewise
> represents the USB gadget as an irqchip to signal GPIO interrupts.
> This shows that LAN95xx is not an isolated case.  gpio-dln2.c does
> not invoke __irq_enter_raw(), so I think users will now see a WARN
> splat with that driver since Mark Rutland's 0953fb263714 (+cc).
> 
> As I've pointed out above, it seems like an oversight that Mark
> didn't make the WARN_ON_ONCE() conditional on handle_enforce_irqctx()
> (as handle_irq_desc() does).  Sadly you did not respond to that
> observation.

When did you make that observation? I can only see an email from you
being sent *after* the one I am replying to.

> Please clarify whether that is indeed erroneous.
> Once handle_enforce_irqctx() is added to generic_handle_domain_irq(),
> there's no need for me to call __irq_enter_raw().  Problem solved.

I don't see it as an oversight. Drivers shouldn't rely on
architectural quirks, and it is much clearer to simply forbid
something that cannot be guaranteed across the board, specially for
something that is as generic as USB.

> Should there be a valid reason for the missing handle_enforce_irqctx(),
> then I propose adding a generic_handle_domain_irq_safe() function which
> calls __irq_enter_raw() (or probably __irq_enter() to get accounting),
> thereby resolving your objection to calling __irq_enter_raw() from a
> driver.

Feel free to submit a patch.

Thanks,

	M.

-- 
Without deviation from the norm, progress is not possible.